      subroutine errmsg3 ( subrname, message, fatal, ibuf)
c ======================================================================
c
c        programmer     Jos van Kan
c        version 1.1    date   04-06-1997
c           isnazification of all variables and subroutine calls
c           all truncated to max 8 characters.
c        version 1.0    10-03-1997
c
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c   pilotcode 3d mgpackage
c
c **********************************************************************
c
c                       MODULES USED
c
      use mgpreset
c **********************************************************************
c
c                       DESCRIPTION
c
c   Errmsg3 keeps track of errors in the MG package. If it encounters
c   a fatal error, or a number of non fatal error it calls the user
c   supplied routine mgexit3. The default is to stop the program, but
c   the user can supply his own error handling.
c **********************************************************************
c
c                       KEYWORDS
c
c   multi_grid
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer ibuf(*)
      character*(*) subrname, message
      logical fatal

c     fatal     i    True if error is fatal.
c     ibuf      i    Integer array of dimension 300 that contains the
c                    administration of this particular multi grid block.
c     message   i    (Error) message (multi grid only)
c     subrname  i    Name of subroutine in which error handler is called
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
c     errcnti   Ibuf (errcnti) contains number of times the error
c               handler has been called for this block. (module
c               mgpreset)
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     MGEXIT3   User supplied routine to exit the package with an error
c               condition. Default: stop. (MG3)
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c **********************************************************************
c
c
c
c                       COMMON BLOCKS
c
c ======================================================================
c
      write (*,*) 'Error in MG subroutine ', subrname, ': ', message
      ibuf (errcnti) =  ibuf (errcnti) + 1
      if (fatal) then
      write (*,*) "Fatal error encountered in multi grid package, "
     +  ,"program halted"
      call mgexit3
      end if

      if (ibuf (errcnti).gt.10) then
      write (*,*) "Program halted, at least 10 errors in multi grid "
      call mgexit3
      end if
      end
