      subroutine getscs3 ( ibuf, size )
c ======================================================================
c
c        programmer     Jos van Kan
c        version 1.1    date   04-06-1997
c           isnazification of all variables and subroutine calls
c           all truncated to max 8 characters.
c        version 1.0    date 10-03-1997
c
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c   pilotcode 3d mgpackage
c
c **********************************************************************
c
c                       MODULES USED
c
      use mgpreset
c **********************************************************************
c
c                       DESCRIPTION
c
c  gets a block of size reals and lower the scratch space offset
c  accordingly.
c  there is rudimentary memory management .
c **********************************************************************
c
c                       KEYWORDS
c
c  multi_grid
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer ibuf(*), size

c     ibuf      i    Integer array of dimension 300 that contains the
c                    administration of this particular multi grid block.
c     size      i    Size of the block
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
c     offrbufi  Ibuf (offrbufi) contains pointer to first unused place
c               in rbuf (module mgpreset)
c     offscri   Ibuf (offscri) contains index where scratch space begins
c               in rbuf (module mgpreset)
c     wirecnti  Ibuf (wirecnti) contains the wirecount (module
c               mgpreset)
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     ERRMSG3   Reports and counts errors (MG3)
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      ibuf (wirecnti) = ibuf (wirecnti) + 1
      ibuf (offscri) = ibuf (offscri) - size
      if (ibuf (offrbufi).gt.ibuf (offscri)) then
      call errmsg3 ('getscrspace', 'max buffersize exceeded', .TRUE.,
     +             ibuf)
      end if
      end
